from datetime import date

from openvariant.plugins.context import Context
from openvariant.plugins.plugin import Plugin


class Add_dateContext(Context):
	"""
	Add_datePlugin class generated by OpenVariant

	Attributes
	-------
	row : dict
		Main method to execute data transformation in each row.
	field_name : str
		Name of the corresponding column that was described on the annotation schema.
	file_path : str
		Path of the Input file that is being parsed.
	"""

	def __init__(self, row: dict, field_name: str, file_path: str) -> None:
		super().__init__(row, field_name, file_path)


class Add_datePlugin(Plugin):
	"""
	Add_datePlugin class generated by OpenVariant

	Methods
	-------
	run(context: Add_dateContext)
		Main method to execute data transformation in each row.
	"""

	def run(self, context: Add_dateContext) -> dict:
		"""
		Data transformation of a single row

		Parameters
		-------
		context : Add_dateContext
			Representation of the row to be parsed.
		
		Returns
		-------
		float or int or str
			The value of the field transformed.
		"""

		# This is an example code, modify if as you wish
		context.row[context.field_name] = str(date.today())

		return context.row[context.field_name]
